﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.2
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private processing As Int = 0
	Private backer As Panel
	Private dlg As Panel	
	Private myActivity As Activity
	Private dlgTaskIsEdit As Boolean = False	
	Private ID As String = "0"
	
	Private valStartDirection As Int = 0
	Private valEndDirection As Int = 0
	Private valStartSpeed As Int = 0
	Private valEndSpeed As Int = 0
	Private dlgW As Int = 200dip
	Private dlgH As Int = 400dip
	Private sldDirection As RoundSlider
	Private FixedPoints() As Int
	Private Direction() As String
	
	Private txtSpeedMin As BRB4XFloatTextField
	Private txtSpeedMax As BRB4XFloatTextField
	Private lblDirection As B4XView
	Public Results As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ma As Activity, idsite As String, startdirection As Int, enddirection As Int, startspeed As Int, endspeed As Int, H As Int, W As Int, editing As Boolean)
	myActivity = ma
	ID = idsite
	valStartDirection = startdirection
	valEndDirection = enddirection
	valStartSpeed = startspeed
	valEndSpeed = endspeed
	dlgH = H
	dlgW = w
	dlgTaskIsEdit = editing
	FixedPoints = Array As Int(0, 22.5, 45,  67.5, 90,  112.5, 135, 157.5, 180, 202.5, 202.5, 247.5, 270, 292.5, 315,  337.5)
	Direction =   Array As String("N", "NNW","NW","NWW", "W","SWW", "SW", "SSW", "S", "SSE", "SE", "SEE",  "E", "ENE", "NE", "NNE")
	Results.Initialize
End Sub

Public Sub Show() As ResumableSub
	backer.Initialize("Pa")
	backer.Color=Colors.ARGB(150,0,0,0)
	myActivity.AddView(backer, 0dip, 0dip, myActivity.Width, myActivity.Height)
	backer.SetElevationAnimated(100, 21dip)
	
	dlg = xui.CreatePanel("")
	dlg.SetLayoutAnimated(10, 0, 0, dlgW, dlgH)
	dlg.LoadLayout("frmAddEdit_WindRule")
	setCornerRadii(dlg,0,0,0,0,30,30,30,30)	' thank you Klaus
	backer.AddView(dlg, (100%x - dlgW) / 2, (100%y - dlgH) / 2, dlgW, dlgH)

	Dim lbl As Label = sldDirection.mBase.GetView(0)
	lbl.Top = lbl.Top - 15dip
	sldDirection.SetCircleColor(Colors.White, Colors.white)
	sldDirection.SetThumbColor(Colors.Blue, Colors.Transparent)
	sldDirection.Draw
	
	sldDirection.Value = valStartDirection
	txtSpeedMin.text = valStartSpeed
	txtSpeedMin.NextField = txtSpeedMax	' should need this but seem to?
	txtSpeedMax.text = valEndSpeed
	
	For fp = 0 To FixedPoints.Length - 1
		If valStartDirection = FixedPoints(fp) Then
			lblDirection.Text = Direction(fp)
		End If
	Next
	
	Do While processing = 0
		Sleep(0)
	Loop
	
	PopulateResults(processing)
	backer.RemoveView
	Return Results
End Sub

Sub PopulateResults(State As Int)
	Results.Put("Sucess", State)
	Results.Put("Degrees", sldDirection.value)
	Results.Put("English", lblDirection.text)
	Dim nMax As Int = txtSpeedMax.text
	Dim nMin As Int = txtSpeedMin.text
	Results.Put("MinSpeed", nMin)
	Results.Put("MaxSpeed", nMax)
End Sub

Sub btnCancel_Click
	processing = 99
End Sub

Sub btnSave_Click
	' add or update the wind rule
	If dlgTaskIsEdit = True Then
		processing = UpdateSiteRule
	Else
		processing = AddSiteRule
	End If
End Sub

private Sub UpdateSiteRule As Int
	' update my database here and return 1 if sucessful
	Return 1
End Sub

Private Sub AddSiteRule As Int
	' insert a new record into my database here and return 1 if sucessful
	Return 1
End Sub

Sub sldDirection_ValueChanged (Value As Int)
	For fp = 0 To FixedPoints.Length - 1
		If Value = FixedPoints(fp) Then
			Return
		End If
	Next

	For fp = 0 To FixedPoints.Length - 1
		If Value > FixedPoints(fp)-10 And Value < FixedPoints(fp)+10 Then
			sldDirection.Value = FixedPoints(fp)
			lblDirection.Text = Direction(fp)
			Exit
		End If
	Next

End Sub

Sub setCornerRadii(v As View, Rx_TopLeft As Float, Ry_TopLeft As Float, Rx_TopRight As Float, Ry_TopRight As Float, Rx_BottomRight As Float, Ry_BottomRight As Float, Rx_BottomLeft As Float, Ry_BottomLeft As Float)
	Dim jo As JavaObject = v.Background
	If v.Background Is ColorDrawable Or v.Background Is GradientDrawable Then
		jo.RunMethod("setCornerRadii", Array As Object(Array As Float(Rx_TopLeft, Ry_TopLeft, Rx_TopRight, Ry_TopRight, Rx_BottomRight, Ry_BottomRight, Rx_BottomLeft, Ry_BottomLeft)))
	End If
End Sub

Sub txtSpeedMin_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtSpeedMin.SetSelection(0, txtSpeedMin.Text.length)
		
	End If
End Sub

Sub txtSpeedMax_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtSpeedMax.SetSelection(0, txtSpeedMax.Text.length)

	End If
End Sub